/**
 * Copyright (C) 2009  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.deployment;

import javax.xml.namespace.QName;

import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;


/**
 *
 * Holds the uuid of the active process version for a process QName.
 *
 * This class should have only one instance stored in database for each processQname.
 *
 * @author Guillaume Porcher
 *
 */
public class ActiveProcessHolder {

  protected long dbid;
  // DB version (to check for concurrent updates)
  protected long dbversion;
  // QName of the process
  protected QName processQName;
  protected ProcessDefinitionUUID processUUID;


  protected ActiveProcessHolder() { }

  /**
   * @param processQName the processQName to set
   */
  public ActiveProcessHolder(final QName processQName) {
    this.processQName = processQName;
  }

  /**
   * @return the processQName
   */
  public QName getProcessQName() {
    return this.processQName;
  }

  /**
   * @param processUUID the processUUID to set
   */
  public void setProcessUUID(final ProcessDefinitionUUID processUUID) {
    this.processUUID = processUUID;
  }

  /**
   * @return the processUUID
   */
  public ProcessDefinitionUUID getProcessUUID() {
    return this.processUUID;
  }


  /**
   * @return the dbid
   */
  public long getDbid() {
    return this.dbid;
  }
}
