/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.env.descriptor;

import java.util.List;

import org.ow2.orchestra.env.WireContext;
import org.ow2.orchestra.util.Misc;


/**
 * @author Guillaume Porcher
 *
 */
public class ChainerDescriptor extends AbstractDescriptor {

  private ListDescriptor listDescriptor;

  public Object construct(final WireContext wireContext) {
    final List<?> l = (List< ? >) wireContext.create(this.listDescriptor, false);
    return Misc.getChainOf(l);
  }


  /**
   * @param listDescriptor the listDescriptor to set
   */
  public void setListDescriptor(final ListDescriptor listDescriptor) {
    this.listDescriptor = listDescriptor;
  }
}
