package org.ow2.orchestra.extension;

import org.ow2.orchestra.definition.BpelProcess;
import org.ow2.orchestra.xml.Binding;
import org.ow2.orchestra.xml.Parse;
import org.w3c.dom.Element;

import java.util.List;

/**
 * @author manhtoan
 */
public interface ExtensionProvider {
    /**
     * key to use to find an object in the wiring context.
     */
    String DEFAULT_KEY = "extensionProvider";

   List<Binding> getDefaultBindings();
   /*
   * To get the path of the extension's schema xml
   * */
  String [] getSchemaResource();

    /*
    * Parse all extensions attributes of an element
    * */
    void parseExtensionAttribute(Element element, Parse parse);

    /*
   * Parse an extension et non-activity element
   * */
    void parseExtensionElement(Element element, Parse parse);

    /**
     * @return if this extension is supported by orchestra
     */
    boolean isSupported(String namespace);

    /*
    * Deploy the needed external module
    * */
    void deployExternalModule(BpelProcess bpelProcess);

    /*
    * UnDeploy the all External Modules of bpelProcess
    * */
    void unDeployExternalModule(BpelProcess bpelProcess);

}
