/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.jmx.commands;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.ow2.orchestra.definition.BpelProcess;
import org.ow2.orchestra.env.Environment;
import org.ow2.orchestra.facade.data.def.ProcessDefinitionData;
import org.ow2.orchestra.services.commands.Command;
import org.ow2.orchestra.util.EnvTool;

public class GetProcessesCommand implements Command<Set<ProcessDefinitionData>> {

  private static final long serialVersionUID = -4282818977685054488L;

  public Set<ProcessDefinitionData> execute(final Environment environment) {
    final List<BpelProcess> bpelProcesses = EnvTool.getRepository().getProcesses();
    final Set<ProcessDefinitionData> result = new HashSet<ProcessDefinitionData>();
    for (final BpelProcess bpelProcess : bpelProcesses) {
      result.add(bpelProcess.getProcessDefinitionData());
    }
    return result;
  }
}
