/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.jmx.commands;

import org.ow2.orchestra.env.Environment;
import org.ow2.orchestra.facade.data.runtime.PendingMessageData;
import org.ow2.orchestra.services.MessageCarrierRepository;
import org.ow2.orchestra.services.PendingMessage;
import org.ow2.orchestra.services.commands.Command;
import org.ow2.orchestra.util.EnvTool;

public final class RemovePendingMessageCommand implements Command<Void> {

  /**
   *
   */
  private final PendingMessageData pendingMessageData;
  private static final long serialVersionUID = 1L;

  /**
   * @param processInstanceUUID
   */
  public RemovePendingMessageCommand(final PendingMessageData pendingMessageData) {
    this.pendingMessageData = pendingMessageData;
  }
  public Void execute(final Environment environment) {
    final PendingMessage pendingMessage = EnvTool.getRepository().getPendingMessage(this.pendingMessageData);
    if (pendingMessage != null) {
      EnvTool.getRepository().removePendingMessage(pendingMessage);
      if (pendingMessage.getMessageCarrierId() != null) {
        MessageCarrierRepository.throwMissingReply(pendingMessage.getMessageCarrierId());

      }
    }
    return null;
  }
}
