/**
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.parsing.binding.extension;

import org.ow2.orchestra.extension.ExtensionProvider;

/**
 * Definition of an extension in BPEL
 *
 * @author manhtoan
 */
public class Extension {
    /**
     * Namespace attribute of the extension element.
     */
    protected String namespace;
    /**
     * mustUnderstand attribute of the extension element.
     */
    protected boolean mustUnderstand;
    protected boolean supported;
    protected ExtensionProvider extensionProvider;

    public Extension(String namespace, boolean mustUnderstand, boolean isSupported) {
        this.namespace = namespace;
        this.mustUnderstand = mustUnderstand;
        this.supported = isSupported;
        this.extensionProvider = null;
    }


    public boolean isMustUnderstand() {
        return mustUnderstand;
    }

    public boolean isSupported() {
        return supported;
    }

    public void setSupported(boolean supported) {
        this.supported = supported;
    }

    public String getNamespace() {
        return namespace;
    }

    public Extension setMustUnderstand(boolean mustUnderstand) {
        this.mustUnderstand = mustUnderstand;
        return this;
    }

    public ExtensionProvider getExtensionProvider() {
        return extensionProvider;
    }

    public void setExtensionProvider(ExtensionProvider extensionProvider) {
        this.extensionProvider = extensionProvider;
    }

    @Override
    public String toString() {
        return "ExtensionDefinition{" + "namespace=" + namespace + "mustUnderstand=" + mustUnderstand + '}';
    }


}
