/*******************************************************************************
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/
package org.ow2.orchestra.persistence.db.hibernate;

import org.hibernate.dialect.MySQL5InnoDBDialect;

/**
 * Dialect used to generate the database schema scripts for MySQL.
 *
 * Use the default Hibernate dialect, but does not generate indexes for foreign keys (indexes are added using the index
 * attribute in hibernate mapping).
 * Using the default Hibernate mapping generates duplicate indexes (see http://jira.ow2.org/browse/ORCHESTRA-14).
 *
 * @author Guillaume Porcher
 */
public class OrchestraMySQL5InnoDBDialect extends MySQL5InnoDBDialect {

  @Override
  public String getAddForeignKeyConstraintString(
          String constraintName,
          String[] foreignKey,
          String referencedTable,
          String[] primaryKey, boolean referencesPrimaryKey) {
    String addFKString = super.getAddForeignKeyConstraintString(
            constraintName,
            foreignKey,
            referencedTable,
            primaryKey,
            referencesPrimaryKey);

    return addFKString.substring(addFKString.indexOf(" add constraint"));
  }
}
