package org.ow2.orchestra.persistence.db.hibernate;

import java.io.Serializable;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;

import javax.xml.namespace.QName;

import org.hibernate.usertype.UserType;

public class QNameUserType implements UserType {

  private static final int[] SQL_TYPES = new int[] { Types.VARCHAR };

  public Object assemble(final Serializable cached, final Object owner) {
    return cached;
  }

  public Object deepCopy(final Object o) {
    return o;
  }

  public Serializable disassemble(final Object o) {
    return (Serializable) o;
  }

  public boolean equals(final Object x, final Object y) {
    if (x == null) {
      return y == null;
    }
    return x.equals(y);
  }

  public int hashCode(final Object o) {
    return o.hashCode();
  }

  public boolean isMutable() {
    return false;
  }

  public Object nullSafeGet(final ResultSet resultSet, final String[] names, final Object owner)
    throws SQLException {
    final String qnameAsString = resultSet.getString(names[0]);
    if (qnameAsString == null) {
      return null;
    }
    return QName.valueOf(qnameAsString);
  }

  public void nullSafeSet(final PreparedStatement preparedStatement, final Object value,
      final int index) throws SQLException {
    if (value != null) {
      final QName qName = (QName) value;
      preparedStatement.setString(index, qName.toString());
    } else {
      preparedStatement.setString(index, null);
    }
  }

  public Object replace(final Object original, final Object target, final Object owner) {
    return target;
  }

  public Class<QName> returnedClass() {
    return QName.class;
  }

  public int[] sqlTypes() {
    return QNameUserType.SQL_TYPES;
  }

}
