/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.services.handlers.impl;

import org.ow2.orchestra.env.Environment;
import org.ow2.orchestra.facade.exception.InstanceNotFoundException;
import org.ow2.orchestra.facade.exception.OrchestraRuntimeException;
import org.ow2.orchestra.jmx.commands.ExitInstanceCommand;
import org.ow2.orchestra.runtime.BpelExecution;
import org.ow2.orchestra.services.job.Job;
import org.ow2.orchestra.services.jobexecutor.DeadJobHandler;


/**
 * @author Guillaume Porcher
 *
 */
public class ExitInstanceDeadJobHandler implements DeadJobHandler {


  public void handleDeadJob(final Job deadJob) {
    final BpelExecution jobExecution = (BpelExecution) deadJob.getExecution();
    if (jobExecution != null) {
      final InstanceNotFoundException e =
        new ExitInstanceCommand(jobExecution.getProcessInstance().getProcessInstanceUUID()).execute(Environment.getCurrent());
      if (e != null) {
        throw new OrchestraRuntimeException(e);
      }
    }
  }

}
