/*
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 */

package org.ow2.orchestra.services.itf;

import javax.servlet.Servlet;
import java.util.Map;
import java.util.Properties;

/**
 * @author manhtoan
 * Interface for objects that should expose servlets in Orchestra.
 *
 * The objects which are in the "httpComponents" list object in the environment will be automatically deployed during orchestra
 * start-up.
 */
public interface HttpComponent {
  /**
   * @return a map containing the collection of servlet to deploy with Orchestra.
   * Key: the servlet context
   * Value: the servlet
   *
   * @param orchestraProperties
   * @return
   */
  Map<String, Servlet> getServlets(Properties orchestraProperties);
}
