package org.ow2.orchestra.services.itf;

import javax.xml.namespace.QName;

import org.ow2.orchestra.services.OpenIMAKey;
import org.ow2.orchestra.var.MessageVariable;

/**
 *
 * @author Tom Baeyens, Charles Souillard
 */
public interface Replier {

  OpenIMAKey getOpenIMAKey();

  /**
   * Called by {@link org.ow2.orchestra.definition.activity.Reply} activity to deliver a reply message.
   *
   * Implementing classes should store the given message (test) or maybe return
   * it through http (ws) or reply to a JMS message (JMS)...
   *
   * @param message
   */
  void reply(MessageVariable message);

  /**
   * Called by {@link org.ow2.orchestra.definition.activity.Reply} activity to deliver a reply fault message.
   *
   * @param faultQName
   * @param message
   */
  void replyWithFault(QName faultQName, MessageVariable message);
}
