package org.ow2.orchestra.services.jobexecutor;

import java.util.Collection;

import org.ow2.orchestra.persistence.db.DbSession;
import org.ow2.orchestra.services.job.JobImpl;

/**
 * internal interface used by the jobImpl executor and the implementations of
 * {@link org.ow2.orchestra.persistence.db.MessageSession} and {@link org.ow2.orchestra.persistence.db.TimerSession}.
 *
 * So this session is only needed in case the {@link JobExecutor} is used to
 * execute messages or timers.
 *
 * @author Tom Baeyens, Pascal Verdage
 */
public interface JobDbSession extends DbSession {

  /** the jobImpl with the given id or null if none */
  JobImpl< ? > getJob(long jobId);

  /**
   * the first jobImpl to finish among eligible and non-locked jobs or null if
   * none
   */
  Collection<JobImpl< ? >> findFirstAcquirableJob(int limit, boolean limitSameInstanceJobs);

  /** the first jobImpl to finish among non-owned jobs or null if none */
  JobImpl< ? > findFirstDueJob();
}
