/**
 * Copyright (C) 2007  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.wsdl;

import java.io.Serializable;

import javax.xml.namespace.QName;

/**
 * @author Goulven Le Jeune, Charles Souillard, Candy Chlad, Stanislas Giraudet
 *         De Boudemange
 */

public class Property implements Serializable {

  /** serialVersionUID. */
  private static final long serialVersionUID = 1L;

  protected QName name;

  protected QName type;

  private QName element;

  /* for hibernate */
  protected Property() { }

  public Property(final QName name) {
    this.name = name;
  }

  public QName getElement() {
    return this.element;
  }

  public void setElement(final QName element) {
    this.element = element;
  }

  public QName getName() {
    return this.name;
  }

  public void setName(final QName name) {
    this.name = name;
  }

  public QName getType() {
    return this.type;
  }

  public void setType(final QName type) {
    this.type = type;
  }

  @Override
  public String toString() {
    // TODO :change the format
    String st = "Property : \n";
    st += "name = " + this.name + "\n";
    if (this.type != null) {
      st += "  type=\"" + this.type.toString() + "\"";
    }

    if (this.element != null) {
      st += " element=\"" + this.element.toString() + "\"";
    }
    return st;
  }

}
